//app存储相关方法
var appBoot = {
  setLocalStorage : function (data,callback){
    // debugger
    if (data) {
      localStorage.clear()        
      globleData.appStorage = JSON.parse(data)
      localStorage[globleData.appData] = data

    }else{
      if (!dsBridge.hasNativeMethod('getEnv') && localStorage[globleData.appData]) 
          globleData.appStorage = JSON.parse(localStorage[globleData.appData]);
      else{
        localStorage.clear()        
      }
    }
    // for (var i in globleData.appStorage) {
    //     localStorage[i] = typeof globleData.appStorage[i] == 'object' ? JSON.stringify(globleData.appStorage[i]) : globleData.appStorage[i]
    //   }
    
    appBoot.fetchTarget();

    if(callback) {
      callback()
      return;
    }
    dsBridge.call('loadOk',function(){})

    appBoot.checkVer(true)

    // dsBridge.call('getSoftwareVersion',function(data, response){
      // globleData.appVersion = data;
      appBoot.setStorageValue('appVersion',globleData.appVersion);
      // appBoot.fetchVersionCheck()

    // })
    //开始游戏
    
  },
  //localStorage get set special data end
  saveDataToApp : function (){
    // debugger
    if(globleData.inAPP && dsBridge.hasNativeMethod('updateDBValue')){
      var obj={
        key: globleData.appData,
        value: JSON.stringify(globleData.appStorage),
        deleteflag: false
      };
      dsBridge.call('updateDBValue',obj,function(){})
    }else{
      localStorage[globleData.appData] = JSON.stringify(globleData.appStorage)
    }  
    
  },
  removeToApp : function(key){  
    if(globleData.inAPP && dsBridge.hasNativeMethod('updateDBValue')){
      var obj={
        key: key,
        deleteflag: true
      };
      dsBridge.call('updateDBValue',obj,function(){})
    }
  },
  
  getFromAppLocalStorage : function(callback){
    
    if(dsBridge.hasNativeMethod('getDBValueWithKey')){
      // alert('getDBValueWithKey');
      dsBridge.call('getDBValueWithKey',globleData.appData,function(data){
        appBoot.setLocalStorage(data,callback);
      })
    }else{
      appBoot.setLocalStorage('',callback);
    }
  },
  setStorageValue : function(key,value,type) {
    if (type) { //存储游戏特殊
      globleData.appStorage[type] = value
    }else{
      globleData.appStorage[key] = value
    }
    appBoot.saveDataToApp();
  },
  fetchRobnotify : function(obj,callback){//获取是否被抢
    html.fetch({
      url:"/red/rob/fetch_notify",
      data:"uid="+globleData.uid,
      success : function (resData){
        if (resData.success) {
          if (resData.result) {
            // if ((!globleData.appStorage.gameRab) || (globleData.appStorage.gameRab && (html.curData() != globleData.appStorage.gameRab))) {
              appBoot.showPop('#wordTips')
              // appBoot.setStorageValue('gameRab',html.curData());
            // }
          }
        }
      },
    })
  },
  fetchActive : function(callback){//获取2,5元活动
    html.fetch({
      url:"/red/limit_withdraw/info",
      data:"uid="+globleData.uid,
      success : function (resData){
        if (resData.success) {
          globleData.activeData = resData.result;

          appBoot.setActive()
          if (globleData.activeCallback) globleData.activeCallback()
        }
      },
    })
  },
  setActive(){
    // globleData.activeData.progress = 5
    clearInterval(globleData.timerSign)
    html.getDom('#signBtn').setAttribute("class","animated pulse2");
    if (globleData.activeData.progress == 2 || globleData.activeData.progress == 5) {
      html.getDom('.signText').innerHTML = !globleData.activeData.signup_time ? '未报名' : '报名成功'
      html.getDom('.tip1').innerHTML = globleData.activeData.progress == 2 ? '明日登录即可直接提现<span style="font-size: 0.8rem;">5</span>元' : '4日后登录即可直接提现<span style="font-size: 0.8rem;">10</span>元'
      
      if (globleData.activeData.left_time < 0) {
        html.getDom('#signBtn').innerHTML = '活动已结束'
        html.getDom('#signBtn').setAttribute("class","gray");
        html.getDom('.leftTime').innerHTML = '活动已结束'
        html.getDom('.signText').innerHTML = '活动已结束'
      }else{
        if (globleData.activeData.signup_time) {
          html.getDom('#signBtn').setAttribute("class","gray");
          html.getDom('#signBtn').innerHTML = '报名成功'
        }else{
          html.getDom('#signBtn').innerHTML = '立即报名'
        }
        appBoot.countDown()
      }
      html.getDom('.tMoney').innerHTML = globleData.activeData.progress == 5 ? '10元' : '5元'
    }
     appBoot.showPop('.tip2')
    if (globleData.activeData.progress == 3 || globleData.activeData.progress == 6) {
      html.getDom('.signText').innerHTML = globleData.activeData.progress == 3 ? '5元活动已结束' : '10元活动已结束'
      html.getDom('.tMoney').innerHTML = '10元'
      html.getDom('#signBtn').innerHTML = '活动预告'
      html.getDom('.leftTime').innerHTML = '活动已结束'
      html.getDom('.tip1').innerHTML = globleData.activeData.progress == 3 ? '下次提现活动预告<br/>2日后，无门槛提现<span style="font-size: 0.8rem;">10</span>元' : ''
      appBoot.closePop('.tip2')
    }
    if (globleData.activeData.progress == 6) {
      html.getDom('#signBtn').removeAttribute("class");
    }

  },
  countDown() {
    let totalTime = globleData.activeData.left_time
    globleData.timerSign = setInterval(()=>{
      if (totalTime >= 0) {
          hour = Math.floor(totalTime / 60/60);

          minutes = Math.floor(totalTime / 60% 60);
          seconds = Math.floor(totalTime % 60);
          html.getDom('.leftTime').innerHTML = "活动倒计时：" + (hour < 10 ? '0' + hour : hour) + ":"+ (minutes < 10 ? '0' + minutes : minutes) + ":" + (seconds < 10 ? '0' + seconds : seconds);
          --totalTime;
      } else{
        appBoot.fetchActive()
          clearInterval(globleData.timerSign);
      }
    },1000)
  },
  activeSignup : function(callback){//获取2,5元活动
    html.fetch({
      url:"/red/limit_withdraw/sign_up",
      data:"uid="+globleData.uid,
      success : function (resData){
        if (resData.success) {
          appBoot.fetchActive()          
        }
      },
    })
  },
  clearConfig : function(callback){//获取个人信息
    html.fetch({
      url:"/user/del_self",
      data:"uid="+globleData.uid+"&os="+globleData.OSTYPE+"&version="+globleData.appVersion,
      success : function (resData){
        if (resData.success) {
          localStorage.clear()
          dsBridge.call('clearConfig', function(data){
            dsBridge.call('exitApp', function(data, response){})
          }); 
        }
      },
    })
  },
  fetchVersionCheck(){//版本检查是否要生级
    html.fetch({
      url:"/multigames/version_check",
      data:"uid="+globleData.uid+"&gtype="+globleData.GTYPE+"&os="+globleData.OSTYPE+"&version="+globleData.appVersion+"&web_ver=20200220",
      success (resData){
        if (resData.success) {
          if (resData.result) {
            // alert(JSON.stringify(resData.result))
            globleData.checkVerData = resData.result;
            if (globleData.appVersion == resData.result.target) { //如果当前版本跟服务器版本相同
              return;
            }
            if (globleData.appStorage.ignoreVer && resData.result.target && globleData.appStorage.ignoreVer == resData.result.target) {
              //如果有忽略版本
              globleData.showUpdateIcon = true;
              return
            }
            if (resData.result.force) {
              appBoot.closePop('.updateLater');
            }
            if (resData.result.url) {
              appBoot.showPop('.popUpdate');
              // appBoot.closePop('.redBaoDiv');
            }
          }
        }
      },
    })
  },
  fetchProfile : function(callback){//获取个人信息
    html.fetch({
      url:"/red/userinfo",
      data:"uid="+globleData.uid+"&os="+globleData.OSTYPE+"&version="+globleData.appVersion+"&web_ver=20200220",
      success : function (resData){
        if (resData.success) {
          globleData.profile = resData.result;
          if (callback) {
            callback()
          }
        }
      },
    })
  },
  fetchRandom : function(callback){//获取随机数设置
    html.fetch({
      url:"/red/fetch_limit",
      data:"uid="+globleData.uid+"&appver="+globleData.appVersion+"&gtype="+globleData.GTYPE,
      success : function (resData){
        if (resData.success) {
          // if(resData.result.continue_game)
            globleData.randomData = resData.result;
            var json = resData.result;
            globleData.randomData.audit_stage = resData.result.audit_stage; 
            for (var i in json) {
              globleData.randomData[i] = json[i]
              // console.log(json[i]) 
            }
            if((globleData.channel != globleData.hideChannel) && globleData.randomData.audit_stage == 3){
              globleData.showRedAll = true
            }else{
              globleData.showRedAll = false
            }
            // globleData.showRedAll = true
          // globleData.randomData.audting = true
          if (callback) callback()
        }
      },
    })
  },
  fetchBonus : function(callback){//获取分红六角
    html.fetch({
      url:"/multigames/bonus_amt",
      data:"uid="+globleData.uid+"&gtype="+globleData.GTYPE,
      success : function (resData){
        if (resData.success) {
          globleData.bonus_amt = resData.result;
          if (callback) callback()
        }
      },
    })
  },
  fetchNotice : function(callback){//获取世界通知
    html.fetch({
      url:"/multigames/fetch_notify",
      data:"uid="+globleData.uid+"&gtype="+globleData.GTYPE+"&start=0&count=100",
      success : function (resData){
        if (resData.success) {
          globleData.noticeData = resData.result
        }
      },
    })
  },
  // prefetchPacket : function(obj,callback){//预告获取金额
  //   html.fetch({
  //     url:"/red/prefetch_packet",
  //     data:"uid="+globleData.uid+"&pos="+obj.pos+(obj.desc ? "&desc="+obj.desc : ''),
  //     success : function (resData){
  //       globleData.hasClick = false
  //       if (resData.success) {
  //         if (callback) callback(resData.result)
  //         // globleData.noticeData = resData.result
  //       }
  //     },
  //     error : callback
  //   })
  // },
  // fetchRobnotify : function(obj,callback){//获取七日内是否被抢
  //   html.fetch({
  //     url:"/red/rob/fetch_notify",
  //     data:"uid="+globleData.uid,
  //     success : function (resData){
  //       if (resData.success) {
  //         if (resData.result) {
  //           if (resData.result && !globleData.appStorage.gameRab) {
  //             appBoot.showPop('#wordTips')
  //             appBoot.computeAD('#wordTips')
  //             appBoot.setStorageValue('gameRab',html.curData());
  //           }
  //         }
  //       }
  //     },
  //   })
  // },
   showNote : function(num, all){
    var str = "";
    str = '看<span> '+ '(' + num + '/' + all + ')' +' </span>次广告，使用该功能'
    html.getDom('.noteText').innerHTML = str;
    appBoot.showPop('#noteTips')
  },
  showGameWheelTips : function(){
    var str = "";
    var strSub = "";
    var num = globleData.chanceTarget-globleData.appStorage.red_count;
    // if(num == 0){
    if (globleData.chanceObj.show) {
      str = "恭喜您获得<span> 提现 </span>机会"
      strSub = "去提现"
      appBoot.showPop('.cancelGameWheel')
    }else{
      str = '再看<span> '+ num +' </span>次广告<span> 提现 </span>'
      strSub = "确定"
      appBoot.closePop('.cancelGameWheel')
    }
    html.getDom('.gameWheelText').innerHTML = str;
    html.getDom('#subGameWheel').innerHTML = strSub;
    appBoot.showPop('#gameWheelTips')
  },
  showDrawPop : function(){
    appBoot.showPop('#drawPop')
    appBoot.computeAD('.drawPop')
  },
  checkLuckdraw : function(){
    if (globleData.chanceObj.show) {
        //弹转盘
        // globleData.appStorage.red_count = 0
        appBoot.showDrawPop()
    }else{
        appBoot.showAdBase(globleData.red_hint_pos, "", function(success){
            if(success){
                // globleData.appStorage.red_count++
                appBoot.addLuckdraw(true)
            }else{
                appBoot.showToast()
            }
        })
    }
  },
  addLuckdraw : function(showToast){
    if(globleData.appStorage.red_count == globleData.chanceTarget /* && globleData.appStorage.chanceDraw == 0*/){
          globleData.chanceObj.show = true
          globleData.chanceObj.leftTime = globleData.openRedTime+":00"
          globleData.appStorage.chanceDraw = new Date().getTime()
          // clearInterval(globleData.timerContinueDraw)
          // appBoot.setTimerDraw(globleData.openRedTime*60*1000)
      }else{
          if(showToast){
            appBoot.showToast("再看"+(globleData.chanceTarget-globleData.appStorage.red_count)+"次广告提现")
          }
          // if(globleData.appStorage.red_count == 1 && globleData.appStorage.continueDeaw == 0){
            globleData.appStorage.continueDeaw = new Date().getTime()
            // appBoot.setTimerContinueDraw(globleData.continueTime*60*1000 - new Date().getTime() + globleData.appStorage.continueDeaw)
          // }
      }
      appBoot.targetStorage()
      // appBoot.saveDataToApp()
      if(globleData.gameWheel) globleData.gameWheel()
      if(globleData.wheelBackIndex) globleData.wheelBackIndex()
  },
  _fetchLuckdraw : function(){//获取抽奖提现转动中奖结果
    var myprize = {}
    globleData.appStorage.luckdrawCount++
    if(globleData.appStorage.luckdrawCount == 4){
      myprize.commdityid = 7;
      myprize.id = 7;
    }else{
      myprize.commdityid = 8;
      myprize.id = 8;
    }
    
    if(myprize.commdityid == 7){
      myprize.extra = html.getRandomIntInclusive(150, 200)
    }
    return myprize;
  },
  fetchLuckdraw : function(){//获取抽奖提现
    // if (!globleData.click) {
    //   return
    // }
    // globleData.click = false
    // 
    // html.fetch({
    //   url:"/red/luckydraw/luckydraw",
    //   data:"uid="+globleData.uid,
    //   success : function (resData){
    //     if (resData.success) {
          // globleData.myprize = resData.result;
          globleData.myprize = appBoot._fetchLuckdraw();
          // this.flagClose = false;
          appBoot.closePop('.closeDraw')
          appBoot.startLottery()
          if(globleData.appStorage.isMusic) html.getDom('.bgm').play()
          globleData.chanceObj = {}
          globleData.appStorage.chanceDraw = 0;
          globleData.appStorage.continueDeaw = 0
          globleData.continueliftTime = globleData.continueTime+":00"
          globleData.appStorage.red_count = 0
          clearInterval(globleData.timerDraw) 
          if (globleData.wheelBackIndex) globleData.wheelBackIndex()
          if (globleData.gameWheel) globleData.gameWheel()
          appBoot.saveDataToApp()
          // appBoot.fetchTarget()
          
    //     }
    //   },
    // })
  },
  startLottery () {
    globleData.speed = 200
    appBoot.startRoll()
  },
  // 开始转动
  startRoll () {
    globleData.times += 1  // 转动次数
    appBoot.oneRoll()  // 转动过程调用的每一次转动方法，这里是第一次调用初始化

    // 如果当前转动次数达到要求 && 目前转到的位置是中奖位置
    if (globleData.times > globleData.cycle && globleData.prize === globleData.curIndex) {
      clearTimeout(globleData.timer)   // 清除转动定时器，停止转动
      
      globleData.times = 0
      globleData.click = true

      console.log('你已经中奖了')
      // let 
      globleData.showAni = true;
      // globleData.$refs.musicPrize.pause()
      html.getDom('#prize'+globleData.prize).setAttribute('class',' .animated pulse2')
      appBoot.showPop('.closeDraw')
      setTimeout(function(){
        html.getDom('#prize'+globleData.prize).setAttribute('class','')
        globleData.prize = -1
        appBoot.closePop('#drawPop')
        // dsBridge.call('infoAdControl',globleData.appAd.off, ()=>{})
        appBoot.showInfoAdControl(false)
        appBoot.getPrize(globleData.myprize)
        html.getDom('.bgm').pause()
        // this.$emit('getPrize',this.myprize)
      },2000)
      
    } else {
      if (globleData.times < globleData.cycle) {
        globleData.speed -= 3   // 加快转动速度
      } else if (globleData.times === globleData.cycle) {    // 随机获得一个中奖位置
        globleData.prize = globleData.PRIZELIST[globleData.myprize.commdityid].index;
        
        // console.log(`中奖位置${globleData.prize}`)
      } else if (globleData.times > globleData.cycle + 10 &&
        ((globleData.prize === 0 && globleData.curIndex === 7) || globleData.prize === globleData.curIndex + 1)) {
        globleData.speed += 60
      } else {
        globleData.speed += 5
      }

      if (globleData.speed < 40) {
        globleData.speed = 40
      }
      
      globleData.timer = setTimeout(appBoot.startRoll, globleData.speed)
    }
  },
  // 每一次转动
  oneRoll () {
    let index = globleData.curIndex  // 当前转动到哪个位置
    const count = globleData.count  // 总共有多少个位置
    index += 1
    if (index > count) {
      index = 1
    }
    
    globleData.curIndex = index
    let priceImg = document.querySelectorAll('.priceCon li img')
    for (var i = 0; i < priceImg.length; i++) {
      priceImg[i].src = './res/img/lottery_1.png'
    }
    // document.querySelectorAll('.priceCon li img').forEach((item,index)=>{
    //   item.src = './res/img/lottery_1.png'
    // })

    // console.log(index)
    html.getDom('#prize'+index + ' img').src = './res/img/lottery_2.png'
  },
  getPrize(data){
    //清除数据
    //清除数据
    // this.flagResult = false;
    
      
      // globleData.chanceObj = {}
      // globleData.appStorage.chanceDraw = 0;
      // clearInterval(globleData.timerDraw)

    if (data.commdityid == 8) {//红包礼包
      appBoot.showAdBase(globleData.red_packet_pos,'' ,appBoot.openRedpacket);
      globleData.appStorage.red_count = 0
      globleData.appStorage.continueDeaw = 0
      globleData.continueliftTime = globleData.continueTime+":00"
      if (globleData.wheelBackIndex) globleData.wheelBackIndex()
      appBoot.saveDataToApp()
    }else{//赠送提现机会
      // debugger
      appBoot.showPop('#getOpDraw')
      globleData.popName = data.commdityid != 7 ? globleData.PRIZELIST[data.commdityid].name : data.extra;
      globleData.popId = globleData.PRIZELIST[data.commdityid].id;
      // globleData.appStorage.chanceFake.push({
      //   id:data.id,
      //   name:globleData.popName,
      //   time:new Date().getTime()
      // })
      appBoot.computeAD('.getOpDraw')
      // dsBridge.call('infoAdControl',globleData.appAd.on, ()=>{})
      html.getDom('.tip12').innerHTML = '恭喜你 获得'+globleData.popName+'元提现机会';
      // this.fetchTarget();
      appBoot.saveDataToApp();
      let TotalClose = 3;
      html.getDom('.closeTem2').innerHTML = TotalClose;
      let closeTimer = setInterval(()=>{
        if (TotalClose <= 0 ) {
          clearInterval(closeTimer)
          appBoot.showPop('.closeImg2')
          appBoot.closePop('.closeTem2')
        }
        TotalClose--
        html.getDom('.closeTem2').innerHTML = TotalClose;
      },1000)
      
    }
    // appBoot.saveDataToApp()
  },
  fetchTarget : function() {
    appBoot.targetStorage()
    if (globleData.gameWheel) globleData.gameWheel()
    if (globleData.wheelBackIndex) globleData.wheelBackIndex()
  },
  targetStorage : function() {
    if(globleData.appStorage.red_count == globleData.chanceTarget){
      if (globleData.appStorage.chanceDraw && (new Date().getTime() - globleData.appStorage.chanceDraw >= globleData.openRedTime*60*1000)) {
          globleData.chanceObj = {}
          globleData.appStorage.continueDeaw = 0
          globleData.continueliftTime = globleData.continueTime+":00"
          globleData.appStorage.red_count = 0
      }else{ //有抽奖机会
          globleData.chanceObj = {show:true,width:0,leftTime:globleData.openRedTime+":00",curTime:globleData.appStorage.chanceDraw}
          appBoot.setTimerDraw(globleData.openRedTime*60*1000 - new Date().getTime() + globleData.chanceObj.curTime)
      }
    }else{
      if (globleData.appStorage.continueDeaw && (new Date().getTime() - globleData.appStorage.continueDeaw >= globleData.continueTime*60*1000)) {  
          globleData.appStorage.continueDeaw = 0
          globleData.appStorage.red_count = 0
      }else{ //有连续机会
          appBoot.setTimerContinueDraw(globleData.continueTime*60*1000 - new Date().getTime() + globleData.appStorage.continueDeaw)
      }      
    }
      
    appBoot.saveDataToApp()
  },
  setTimerContinueDraw(totalTime){//连续机会消失
    let totalTimes = totalTime;
    clearInterval(globleData.timerContinueDraw)
    clearInterval(globleData.timerDraw) 
    globleData.timerContinueDraw = setInterval(()=>{
      if (totalTimes <= 1000) {
        globleData.appStorage.continueDeaw = 0
        globleData.continueliftTime = globleData.continueTime+":00"
        globleData.appStorage.red_count = 0
        appBoot.saveDataToApp()
        if (globleData.gameWheel) globleData.gameWheel()
        if (globleData.wheelBackIndex) globleData.wheelBackIndex()
        clearInterval(globleData.timerContinueDraw)
      }else{
        totalTimes = totalTimes - 1000;
        globleData.continueliftTime = html.formatTime(totalTimes);
        if (globleData.wheelBackIndex) globleData.wheelBackIndex()
      }
    },1000)
  },
  setTimerDraw(totalTime){//转盘机会消失
    let totalTimes = totalTime;
      // console.log(totalTimes)
    html.getDom('.drawTimeText').innerHTML = html.formatTime(totalTimes)
    clearInterval(globleData.timerDraw)
    clearInterval(globleData.timerContinueDraw)
    globleData.timerDraw = setInterval(()=>{
      if (totalTimes <= 1000) {
        // if (globleData.timerArr) {
               
          globleData.appStorage.chanceDraw = 0
          globleData.chanceObj = {}
          globleData.appStorage.continueDeaw = 0
          globleData.continueliftTime = globleData.continueTime+":00"
          globleData.appStorage.red_count = 0
          appBoot.saveDataToApp()
          if (globleData.gameWheel) globleData.gameWheel()
          if (globleData.wheelBackIndex) globleData.wheelBackIndex()
          clearInterval(globleData.timerDraw)   
        // }
      }else{
        totalTimes = totalTimes - 1000;
        globleData.chanceObj.leftTime = html.formatTime(totalTimes);
        html.getDom('.drawTimeText').innerHTML = html.formatTime(totalTimes)
        globleData.chanceObj.width = totalTimes/(100*60) + '%';
        if (globleData.wheelBackIndex) globleData.wheelBackIndex()
      }
      // console.log('转盘： '+totalTimes + ':task=' + globleData.taskNum)
    },1000)
  },
  dsAdResult : function(){ //广告回调接收
    if(globleData.isAdResult){
        return;
    }
    // alert("dsAdResult g_dsPos="+g_dsPos);
    dsBridge.register('adresult', function(data, responseCallback) { //全屏广告跳过app回的是失败 noad=true        
        var state = globleData.dsState;
        var pos = globleData.dsPos;
        var callback = globleData.dsCallback;
        var curResult = ''
        if(typeof data == 'string'){
            data = JSON.parse(data);
        }
        globleData.isAdResult = 1;
        if (data.name == pos) {
          if(data.display == undefined){
            if(typeof callback == "function"){
              callback(false);
            }
          }else{
            if (data.display) {
              if(data.name == globleData.red_hint_pos || data.name == globleData.red_packet_pos || data.name == globleData.red_double_pos){
                globleData.appStorage.red_count++
                if(globleData.appStorage.red_count > globleData.chanceTarget){
                  globleData.appStorage.red_count = globleData.chanceTarget
                }
                appBoot.saveDataToApp()
              }
              if(data.name == globleData.red_double_pos){
                    if(globleData.appStorage.red_count == 1){
                      globleData.appStorage.red_count = 0
                      globleData.appStorage.continueDeaw = 0
                      globleData.continueliftTime = globleData.continueTime+":00"
                      appBoot.saveDataToApp()
                    }
                    data = data.result
                    if(typeof data == 'string'){
                        data = JSON.parse(data);
                    }
                    data = data.gift;
                    if(typeof data == 'string'){
                        data = JSON.parse(data);
                    } 
                    appBoot.addLuckdraw()
                    if(typeof callback == "function"){
                      callback(true, data); 
                    } 
              }else{
                  appBoot.addLuckdraw()
                  if(typeof callback == "function"){
                    callback(true)
                  }
              } 
              // if(globleData.appStorage.red_count == 1){
              //   globleData.appStorage.continueDeaw = new Date().getTime()
              //   appBoot.saveDataToApp()
              //   appBoot.setTimerContinueDraw(globleData.continueTime*60*1000 - new Date().getTime() + globleData.appStorage.continueDeaw)
              // }
              // if (globleData.gameWheel) globleData.gameWheel()
              // if (globleData.wheelBackIndex) globleData.wheelBackIndex() 
              // appBoot.addLuckdraw()
            }else{
              if(typeof callback == "function"){
                callback(false);
              }
            }
          }
        }
    })
  },
  _showAdBase : function(pos, param, callback){//获取游戏广告
    if (pos != '-1') {
      if (globleData.sys_config_data) {
        var state = globleData.sys_config_data.position;
            // debugger
            if(state[pos]){
              if(state[pos].show_rate > 0){
                
                if (globleData.inAPP) {

                  dsBridge.call('displayAD',state[pos],function(){})
                  globleData.dsState = state[pos];
                  globleData.dsPos = pos;
                  globleData.dsCallback = callback;
                  globleData.sys_config_data = null
                }else{
                  var str = {type: "amount", number: "0.12", balance_info: "89.34", red_count: null}
                  if(typeof callback == "function"){
                    callback(true,str);
                  }
                }
              }else{
                if(typeof callback == "function"){
                  callback(false);
                }
              }
            }else{
              var str = {type: "amount", number: "0.12", balance_info: "89.34", red_count: null}
                if(typeof callback == "function"){
                  callback(true,str);
                }
            }
      }else{
        if(typeof callback == "function"){
          // appBoot.showToast(6)
          callback(false);
        }
      }
      globleData.clickAD = false

    }
    html.fetch({
      url:"/multigames/sys_config",
      data:"uid="+globleData.uid+"&os="+globleData.OSTYPE  
        +"&gtype="+globleData.GTYPE+'&pos=&app_ver='+globleData.appVersion+"&channel="+globleData.channel,
      success : function (resData){
        if (resData.success) {
          var result = resData.result;
          globleData.sys_config_data = resData.result;
          
        }else{
          // if(typeof callback == "function"){
          //   // appBoot.showToast(6)
          //   callback(false);
          // }  
          globleData.sys_config_data = null    
        }
      },
      error : callback
    })
  },
  showAdBase : function(pos, param, callback){//获取游戏广告
    // var str = {type: "amount", number: "0.12", balance_info: "89.34", red_count: 1};
    // if(pos == globleData.red_hint_pos || pos == globleData.red_packet_pos || pos == globleData.red_double_pos){
    //   globleData.appStorage.red_count++
    //   if(globleData.appStorage.red_count > globleData.chanceTarget){
    //     globleData.appStorage.red_count = globleData.chanceTarget
    //   }
    //   appBoot.saveDataToApp()
    // }
    // if(pos == globleData.red_double_pos){
    //     if(globleData.appStorage.red_count == 1){
    //       globleData.appStorage.red_count = 0
    //       globleData.appStorage.continueDeaw = 0
    //       globleData.continueliftTime = globleData.continueTime+":00"
    //       appBoot.saveDataToApp()
    //     }
    //     appBoot.addLuckdraw() 
    // }else{
    //     appBoot.addLuckdraw()
    // } 

    // if(typeof callback == "function"){
    //   callback(true);
    // }
    // return
      if(globleData.randomData.audit_stage == 1){
        if(pos == globleData.red_hint_pos){
          pos = globleData.red_complete_pos
          appBoot._showAdBase(pos, param, callback)
        }else{
          callback(true)
        }
      }else{
        appBoot._showAdBase(pos, param, callback)
      }
    // if(globleData.randomData.audit_stage == 1){
    //   if(pos == globleData.red_hint_pos){
    //     pos = globleData.red_complete_pos
    //     appBoot._showAdBase(pos, param, callback)
    //   }else{
    //     callback(true)
    //   }
    // }else{
    //   appBoot._showAdBase(pos, param, callback)
    // }
  },
  showAdHintNote : function(callback){//激励 标记所有
    if(globleData.randomData.audit_stage == 1){
      if (globleData.SolvePress) globleData.SolvePress()
      return
    }
    appBoot.showAdBase(globleData.red_hint_pos, "", function(success){
        if(success){
          globleData.appStorage.hintNoteNum += 1
          appBoot.setStorageValue('hintNoteNum', globleData.appStorage.hintNoteNum);
          if(globleData.appStorage.hintNoteNum >= Number(globleData.randomData.noteAll)){
            // callback(true)
            appBoot.closePop('#noteTips')
            if (globleData.SolvePress) globleData.SolvePress()
            appBoot.setStorageValue('hintNoteNum', 0);
          }else{
            appBoot.showNote(globleData.appStorage.hintNoteNum, Number(globleData.randomData.noteAll))
          }
        }else{
          appBoot.showToast()
        }
    })         
  },
  showAdHintShowAll : function(callback){//激励 显示结果
    if(globleData.randomData.audit_stage == 1){
      if (globleData.SolvePress) globleData.SolvePress()
      return
    }
    appBoot.showAdBase(globleData.red_hint_pos, "", function(success){
        if(success){
          globleData.appStorage.hintAllNum += 1
          appBoot.setStorageValue('hintAllNum', globleData.appStorage.hintAllNum);
          if(globleData.appStorage.hintAllNum >= Number(globleData.randomData.writeAll)){
            // callback(true)
            appBoot.closePop('#noteTips')
            if (globleData.SolvePress) globleData.SolvePress()
            appBoot.setStorageValue('hintAllNum', 0);
          }else{
            appBoot.showNote(globleData.appStorage.hintAllNum, Number(globleData.randomData.writeAll))
          }
        }else{
          appBoot.showToast()
        }
    })        
  },
  showAdHintComplete : function(force, callback){//新插屏广告
    if(force){            
        appBoot.showAdBase(globleData.red_hint_complete_pos, "", function(){callback(true);});
    }else{
        globleData.appStorage.movePageNum += 1
        appBoot.setStorageValue('movePageNum', globleData.appStorage.movePageNum);
        if(globleData.appStorage.movePageNum >= 2){
          appBoot.setStorageValue('movePageNum', 0);              
          appBoot.showAdBase(globleData.red_hint_complete_pos, "", function(){callback(true);});
        }else{
          callback(true);
        }
    }
    // if(typeof callback == "function"){
    //   callback(true);
    // }          
  },
  showAdHintCompleteGame : function(force, callback){//新插屏广告 标记，默认3次
    if(force){            
        appBoot.showAdBase(globleData.red_hint_complete_pos, "", function(){
          if(typeof callback == "function"){
              callback(true);
          }
        });
    }else{
        globleData.appStorage.upNum += 1
        appBoot.setStorageValue('upNum', globleData.appStorage.upNum);
        // if(globleData.appStorage.penHintCompleteNum >= globleData.randomData.red_packet){
        if(globleData.appStorage.upNum >= 3){
          appBoot.setStorageValue('upNum', 0);              
          appBoot.showAdBase(globleData.red_hint_complete_pos, "", function(){
            if(typeof callback == "function"){
              callback(true);
            } 
          });
        }else{
          if(typeof callback == "function"){
            callback(true);
          } 
        }
    }
    // if(typeof callback == "function"){
    //   callback(true);
    // }          
  },
  showInfoAdControl : function(on){
    if(globleData.randomData.audit_stage == 1){
      return
    }
    if(on){
      dsBridge.call('infoAdControl',globleData.appAd.on, function(){})
    }else{
      dsBridge.call('infoAdControl',globleData.appAd.off, function(){})
    }
  },
//    bannerControl接口的参数现在支持两种
// 1. 旧的true/false
// 2. json结构体， {"enable": true, "inBottom": false},   
// enable用来控制显示或者关闭, 
// inBottom用来控制底部还是顶部
  showBannerAD : function(on, bootm){
    if(globleData.randomData.audit_stage == 1){
      return
    }
    // if(on){
    //   dsBridge.call('bannerControl',true, ()=>{})
    // }else{
    //   dsBridge.call('bannerControl',false, ()=>{})
    // }
    if(bootm == undefined) bootm = true
    dsBridge.call('bannerControl',{"enable":on, "inBottom":bootm}, function(){})
  },
  fetchRedPacket : function(callback){//看广告获取随机红包金额
    if(navigator.onLine == false){
      callback(false, "offline")
      return;
    }
    if(!globleData.inAPP){
      if(typeof callback == "function"){
        var str = {type: "amount", number: "0.12", balance_info: "89.34", red_count: 1};
        callback(true, str);
        // if(globleData.appStorage.firstOpen){
        //   appBoot.setStorageValue('firstOpen',false);
        // }
      }
      globleData.closeClick = false
      return;
    }
    var tmNow = (new Date()).getTime();
    var hash = "";
    dsBridge.call('calcHash', globleData.uid+tmNow ,function(data, response){
      hash = data;
      html.fetch({
        url:"/red/red_packet",
        data:"uid="+globleData.uid+"&hash="+hash+"&ver="+globleData.appStorage.appVersion+"&tm="+tmNow,
        success : function (resData){
          if (resData.success) {
            var resultData = resData.result;
              // alert('开红包成功')
              // alert(JSON.stringify(resultData))
              // globleData.appStorage.redOpened++
              // appBoot.setStorageValue('redOpened',globleData.appStorage.redOpened)
              if(resultData.type == 'amount'){
                // if (resultData.red_count) {
                //   globleData.profile.red_count = resultData.red_count
                //   globleData.profile.today_red_count = resultData.today_red_count
                //   appBoot.fetchTarget();
                // }
                callback(true, resultData)
              }else{
                callback(false)
              }
          }
          globleData.closeClick = false
        },
        error : callback
      })  
    })
  },
  showLimit : function (argument) {
      appBoot.showPop('#limitDiv');
      appBoot.fetchActive()
      appBoot.bannerAD('.singPop')
  },
  _showSetting : function (sound, time) {
    if(globleData.channel == globleData.hideChannel){    
        html.getDom('#clearSet').setAttribute("class", "clearSetOnly");
        appBoot.closePop('.showChet');
        appBoot.closePop('.showUpdate');
        // if(globleData.randomData.audit_stage == 3){
        //   appBoot.showPop('.showChet');
        //   if(globleData.showUpdateIcon){
        //     html.getDom('#clearSet').setAttribute("class", "clearSet");
        //     html.getDom('#chatSet').setAttribute("class", "chatSet");
        //     appBoot.showPop('.showUpdate');
        //   }else{
        //     html.getDom('#clearSet').setAttribute("class", "clearSetNoUp");
        //     html.getDom('#chatSet').setAttribute("class", "chatSetNoUp");
        //     appBoot.closePop('.showUpdate');
        //   }
        // }
    }else{
        // if(globleData.randomData.audit_stage == 1 || globleData.randomData.audit_stage == 2){
          appBoot.closePop('.showChet');
          if(globleData.showUpdateIcon){
            appBoot.showPop('.showUpdate');
            html.getDom('#clearSet').setAttribute("class", "clearSetNoUp");
            html.getDom('#updateSet').setAttribute("class", "chatSetNoUp");
          }else{
            html.getDom('#clearSet').setAttribute("class", "clearSetOnly");
            appBoot.closePop('.showUpdate');
          }
        // }else{
        //   appBoot.showPop('.showChet');
        //   if(globleData.showUpdateIcon){
        //     html.getDom('#clearSet').setAttribute("class", "clearSet");
        //     html.getDom('#chatSet').setAttribute("class", "chatSet");
        //     appBoot.showPop('.showUpdate');
        //   }else{
        //     html.getDom('#clearSet').setAttribute("class", "clearSetNoUp");
        //     html.getDom('#chatSet').setAttribute("class", "chatSetNoUp");
        //     appBoot.closePop('.showUpdate');
        //   }
        // }
    }
    html.getDom('#nickID').innerHTML = globleData.profile.nick+"("+globleData.uid+")"
    html.getDom('#verID').innerHTML = globleData.webVersion+"/"+globleData.appVersion
    var verStr = (globleData.using_x5 ? (globleData.webVersion+"/"+globleData.appVersion+"/X5") : (globleData.webVersion+"/"+globleData.appVersion) )
    html.getDom('#verID').innerHTML = verStr

    appBoot.showPop('#stetting');
    appBoot.computeAD('#stetting .dialog-content-ver');
  },
  showSetting : function (sound, time) {
    if(sound){
      html.getDom("#setSoundIn").setAttribute('checked',true)
    }else{
      html.getDom("#setSoundIn").setAttribute('checked',false)
    }
    if(time){
      html.getDom("#setTimeIn").setAttribute('checked',true)
    }else{
      html.getDom("#setTimeIn").setAttribute('checked',false)
    }
    if(dsBridge.hasNativeMethod('getEnv')){
      dsBridge.call('getEnv',function(data, response){
        if(typeof data == 'string'){
         data = JSON.parse(data);
        }
        if (data.real_name) {
          var realName = data.real_name
          if(typeof data.real_name == 'string'){
            realName = JSON.parse(data.real_name);
          }
          if(realName.name)
            appBoot.showPop("#realName")
          else
            appBoot.closePop("#realName")
        }else{
          appBoot.closePop("#realName")
        }
        appBoot._showSetting()
      })
    }else{
      appBoot._showSetting()
    }
  },
  checkRealName: function(){
    if(globleData.realName){
      return true
    }
    if(dsBridge.hasNativeMethod('getEnv')){
      dsBridge.call('getEnv',function(data, response){
        if(typeof data == 'string'){
         data = JSON.parse(data);
        }
        if (data.real_name) {
          var realName = data.real_name
          if(typeof data.real_name == 'string'){
            realName = JSON.parse(data.real_name);
          }
          if(realName.name)
            return true
          else
            return false
        }else{
          return false
        }
      })
    }else{
      return false
    }
  },
  showCheckAdd : function () {
    appBoot.showPop('#checkAdd');
    // appBoot.computeAD('#checkAdd .dialog-content-ver');
  },
  showCheckBtn : function () {
    appBoot.showPop('#checkBtn');
    appBoot.computeAD('#checkBtn .dialog-content-ver');
  },
  showCheckNull : function () {
    appBoot.showPop('#checkNull');
    appBoot.computeAD('#checkNull .dialog-content-ver');
  },
  showExitPop : function () {
    appBoot.showPop('#exitPop');
    appBoot.computeAD('#exitPop .dialog-content-ver');
  },
  showPauseGame : function () {
    appBoot.showPop('#pauseGame');
    appBoot.computeAD('#pauseGame .dialog-content');
  },
  showWinGame : function (diff) {
    var str = '简单'
    var num = '50'
    if(diff == 2){
      str = '困难'
      num = '80'
    }else if(diff == 1){
      str = '标准'
      num = '70'
    }
    html.getDom('.winGameText1').innerHTML = str+'模式<span>1000</span>关'
    html.getDom('.winGameText2').innerHTML = '您已经超越'+num+'%的数独高手'
    appBoot.showPop('#winGame');
  },
  showRank : function () {
    appBoot.tabRank(globleData.GTYPE+"0")
    appBoot.showPop('#rank');
  },
  fetchRank : function(diff, callback){//获取排行榜
    html.fetch({
      url:"/red/board/fetch_board",
      data:"uid="+globleData.uid+"&bname="+diff,
      success : function (resData){
        if (resData.success) {
          if(resData.result){
            globleData.rank = resData.result;
            globleData.rankMinScore[diff] = resData.result.minScore;
          }else{
            globleData.rank = {}
          }
          if (callback) callback(diff)
        }
      },
    })
  },
  /*
/red/board/fetch_min_score
uid
bnames
模式名称，你可以用gtype+0/1
  */
  fetchRankMinScore : function(diff){//获取最低上榜分数
    if(!diff){
      var diffs = globleData.GTYPE+"0,"+globleData.uid+"1"
    }else{
      var diffs = diff
    }
    html.fetch({
      url:"/red/board/fetch_min_score",
      data:"uid="+globleData.uid+"&bnames="+diffs,
      success : function (resData){
        if (resData.success) {
          if(resData.result){
            globleData.rankMinScore = resData.result;
          }
        }
      },
    })
  },
  tabRank : function (diff) {
    appBoot.fetchRank(diff, appBoot._tabRank)
  },
  _tabRank : function (diff) {
    // var tabs = html.getDom('.tabMenuOne')
    var tabs = document.getElementsByClassName('tabMenuOne')
    for (var i = tabs.length - 1; i >= 0; i--) {
      if(diff.indexOf(String(i)) > 0){
        tabs[i].setAttribute("class", "tabActive tabMenuOne");
      }else{
        tabs[i].setAttribute("class", "tabNone tabMenuOne");
      }
    }
    var titleBox = document.getElementById('titleBox')
    var titleitems=titleBox.getElementsByTagName("dl"); 
    var titleitemss=titleitems[0].getElementsByTagName("dd"); 
    if(diff.indexOf("0") > 0){
      titleitemss[2].innerHTML = "最高关卡"
    }else{
      titleitemss[2].innerHTML = "最高积分"
    }

    var tabBox=document.getElementById("tabBox"); 
    var items=tabBox.getElementsByTagName("ul"); 
    var itemss=items[0].getElementsByTagName("li"); 
    var len = globleData.rank.list == undefined ? 0 : globleData.rank.list.length 
    var list = globleData.rank.list
    for (var i = itemss.length - 1; i >= 0; i--) {
      if(i<=len || i == 0){
        itemss[i].style.display = 'block'
        var dl = itemss[i].getElementsByTagName("dl"); 
        var dd = dl[0].getElementsByTagName("dd");
        if(i == 0){
          dd[0].innerHTML = globleData.rank.myseq == undefined ? "999+" : globleData.rank.myseq
          dd[1].innerHTML = "我"
          var str = "----"
          if(globleData.appStorage["bestScore_" + diff] == undefined){
            str = "----"
          }else{
            str = globleData.appStorage["bestScore_" + diff]
          }
          dd[2].innerHTML = str
          // if(globleData.appStorage["Sudoku_ultimate_bestTime_" + diff.toString()] == undefined){
          //   str = "----"
          // }else{
          //   str = appBoot.formatSeconds(globleData.appStorage["Sudoku_ultimate_bestTime_" + diff.toString()])
          // }
          // dd[3].innerHTML = str
          if(globleData.appStorage["bestLevel_" + diff] == undefined){
            str = "----"
          }else{
            str = globleData.appStorage["bestLevel_" + diff]
          }
          dd[3].innerHTML = str
        }else{
          if(list[i-1].uid == Number(globleData.uid)){
            itemss[i].style.background = '#1c3c70'
          }else{
            itemss[i].style.background = 'none'
          }
          dd[0].innerHTML = list[i-1].seq
          // if(list[i-1].uid == globleData.uid){
          //   dd[1].innerHTML = "我"
          // }else{
            dd[1].innerHTML = list[i-1].nick.slice(2)
          // }
          // 原始score=上报score/1000 截取小数取整
          dd[2].innerHTML = Math.floor((list[i-1].score)/1000)
          // dd[3].innerHTML = appBoot.formatSeconds(list[i-1].time)
          // dd[4].innerHTML = list[i-1].level
          dd[3].innerHTML = (list[i-1].score)%1000
        }
      }else{
        // 没有 10条数据 隐藏li
        itemss[i].style.display = 'none'
      }
    }
  },
  reportFormatTime : function (e) {
      // e /= 1e3;
      var t = Math.floor(e / 60)
        , n = Math.floor(e - 60 * t)
        , i = "";
      return i += 10 > t ? "0" + t + ":" : t + ":",
      i += 10 > n ? "0" + n : n
  },
  formatSeconds:function (value) { 
    var theTime = parseInt(value);// 秒 
    var theTime1 = 0;// 分 
    var theTime2 = 0;// 小时 
    var result = "00:00"
    // alert(theTime); 
    if(theTime > 60) { 
      theTime1 = parseInt(theTime/60); 
      theTime = parseInt(theTime%60);
      if(theTime1 > 60) { 
        theTime2 = parseInt(theTime1/60); 
        theTime1 = parseInt(theTime1%60); 
        var theTimeStr = theTime < 10 ? '0' + theTime : theTime
        var theTime1Str = theTime1 < 10 ? '0' + theTime1 : theTime1
        var theTime2Str = theTime2 < 10 ? '0' + theTime2 : theTime2
        result = theTime2Str+":"+theTime1Str+":"+theTimeStr;
      }else{
        var theTimeStr = theTime < 10 ? '0' + theTime : theTime
        var theTime1Str = theTime1 < 10 ? '0' + theTime1 : theTime1
        result = theTime1Str+":"+theTimeStr;
      }
    }else{
      var theTimeStr = theTime < 10 ? '0' + theTime : theTime
      result = "00:"+theTimeStr; 
    }

    return result; 
  },
  /*
/red/update_board
uid 
bname  模式名称，你可以用gtype+0/1
score
  */
  fetchRankReport : function(score, level, diff, callback){//获取排行榜
    var str = score*1000+level
    html.fetch({
      url:"/red/board/update_board ",
      data:"uid="+globleData.uid+"&bname="+diff+"&score="+str,
      success : function (resData){
        if (resData.success) {
          if(resData.result)
            globleData.rankMinScore[diff] = resData.result.score;
          if (callback) callback()
        }
      },
    })
  },
  reportRank : function (score, diff) {
    var bestScore = globleData.appStorage["bestScore_" + diff]
    var bestLevel = globleData.appStorage["bestLevel_" + diff]
    var level = appBoot.getMaxHeroes()
    console.log("quying reportRank diff="+diff+"; level="+level+"; score="+score)
    console.log("quying reportRank diff="+diff+"; bestLevel="+bestLevel+"; bestScore="+bestScore)
    var update = false
    if(bestScore == undefined || score > bestScore){
      bestScore = score
      if(globleData.rankMinScore[diff] == undefined || bestScore >= Math.floor((Number(globleData.rankMinScore[diff]))/1000)){
        update = true
      }
    }
    // if(bestTime == undefined || time < bestTime){
    //   bestTime = time
    //   if(globleData.rankMinScore[diff] == undefined || bestScore >= Number(globleData.rankMinScore[diff])){
    //     update = true
    //   }
    // }
    if(bestLevel == undefined || level > bestLevel){
      bestLevel = level
      if(globleData.rankMinScore[diff] == undefined || bestScore >= ((Number(globleData.rankMinScore[diff]))%1000)){
        update = true
      }
    }
    appBoot.setStorageValue("bestScore_" + diff, bestScore);
    // appBoot.setStorageValue("Sudoku_ultimate_bestTime_" + diff.toString(), bestTime);
    appBoot.setStorageValue("bestLevel_" + diff, bestLevel);
    if(update){
      appBoot.fetchRankReport(bestScore, bestLevel, diff)
    }
  },
  getMaxHeroes:function(){
    var Heroes = JSON.parse(globleData.appStorage.PUBGxZombie_Heroes)
    var maxLevel = 0
    for (var i in Heroes) {
      if(maxLevel < Heroes[i].level){
        maxLevel = Heroes[i].level
      }
    }
    console.log(maxLevel)
    return maxLevel
  },
  showToast : function(text){
    globleData.btnClicked = false;
    html.getDom('.errorTips').innerHTML = text || '播放视频失败，请稍后再试';
    appBoot.showPop('.showToast');
    setTimeout(function(argument) {
      appBoot.closePop('.showToast');
    },2000)
  },
  closePop : function(name){ //show页面元素
    var nameArry = name.split(',')
    for (var i = 0; i < nameArry.length; i++) {
      html.getDom(nameArry[i]).style.display = 'none'
    }
  },
  showPop : function(name){ //hide页面元素
    var nameArry = name.split(',')
    for (var i = 0; i < nameArry.length; i++) {
      html.getDom(nameArry[i]).removeAttribute('style')
    }
  },
  skipCheckVer(){//跳过版本检测
    appBoot.setStorageValue('skipX5',1);
    appBoot.closePop('#ver,#ver3,#ver2');
    clearInterval(globleData.varTimeId);//关闭检测定时器
    appBoot.init();
  },
  startCheckVer(){
    appBoot.closePop('#ver,#ver3');
    appBoot.showPop('#ver2');
    globleData.varTimeId = setInterval(function(){
      appBoot.checkVer(false);
    }, 2000);
  },
  checkVer(first){
    if(globleData.appStorage.skipX5 == 1){
      appBoot.closePop('#ver,#ver3,#ver2');
      appBoot.init();
      if(first != true){
        clearInterval(globleData.varTimeId);
      }
      return;
    }
    function boolToNumber(data) {
      if(data == true){
        return 1;
      }else{
        return 0;
      }
    }
    if(dsBridge.hasNativeMethod('getX5Info')){
      // alert("getX5Info");
      dsBridge.call('getX5Info',function(data, response){
        if(typeof data == 'string'){
            data = JSON.parse(data);
        }
        // alert(data)
        globleData.using_x5 = data.using_x5
        // alert("using_x5="+data.using_x5+"; x5_loaded="+data.x5_loaded);
        html.getDom('#status_ver').innerHTML = boolToNumber(data.using_x5)+"/"+boolToNumber(data.x5_loaded);
        if(data.os >= 26){
          appBoot.closePop('#ver,#ver3,#ver2');
          appBoot.init();
          if(first != true){
            clearInterval(globleData.varTimeId);;
          }
        }else{
          if(data.using_x5){
            if(first == true){
              appBoot.closePop('#ver,#ver3,#ver2');
              appBoot.init();
            }else{
              if(data.x5_loaded){
                clearInterval(globleData.varTimeId);;
                appBoot.closePop('#ver,#ver3,#ver2');
                appBoot.showPop('#ver3');
              }
            }
          }else{
            if(first == true){
              appBoot.showPop('#ver');
            }else{
              if(data.x5_loaded){
                clearInterval(globleData.varTimeId);;
                appBoot.closePop('#ver,#ver3,#ver2');
                appBoot.showPop('#ver3');
              }
            }
          }
        }
      })
    }else{
      appBoot.closePop('#ver,#ver3,#ver2');
      appBoot.init();
    }
  },
  exitApp() {
    dsBridge.call('exitApp', function(data, response){})
  },
  btnWithdraw(){
    if (globleData.gameSound) globleData.gameSound()
    html.gotoWebpage('/my/withdraw','支付宝提现')
    // if (Number(globleData.profile.amount) >= 150) {
    //   html.gotoWebpage('/my/withdraw','支付宝提现')
    // }else{
    //   appBoot.showPop('.withTips')
    // }
  },
  openBalance(){
    if (globleData.gameSound) globleData.gameSound()   
    // dsBridge.call('infoAdControl',globleData.appAd.on, ()=>{})
    html.getDom('.pclose2').setAttribute("class","btnWith pclose2");
    appBoot.showPop('.popWith,.mask,.imgbg2')
    appBoot.closePop('.redShow,.withTips')
    html.getDom('.redValue2').innerHTML = globleData.profile.amount + '<span>元</span>'
    html.getDom('.redText').innerHTML = '红包余额'
    html.getDom('.pclose2').innerHTML = '继续赚红包'
    appBoot.computeAD('.popDiv')
  },
  openGift(){
    appBoot.showPop('.firstDiv,.mask,.imgbg') 
    if(globleData.channel != globleData.hideChannel) appBoot.closePop('.oclose')
    html.getDom('.redValue').innerHTML = '恭喜获得，新手礼包'
    document.querySelector('.popDiv').style['margin-top'] = '0%'
  },
  openAdiv(soudFlag){
    // if (!soudFlag) {
    //   if (html.getDom('.imgbg').style.display != 'none' || html.getDom('.imgbg2').style.display != 'none') 
    //     return
    //   // globleData.appStorage.showRedpacket[heroData.level+heroData.smile] = true;
      
    //   if (globleData.appStorage.hasRed) {
    //     if (globleData.appStorage.hasRed % globleData.randomData.param_f == 0) {
    //       appBoot.showPop('.firstDiv,.mask,.imgbg,.oclose') 
    //     }else{
    //       globleData.showRedpacket()
    //     }
        
    //   }else{
    //     appBoot.showPop('.firstDiv,.mask,.imgbg,.oclose')    
    //   }
    //   globleData.appStorage.hasRed++
    //   appBoot.setStorageValue('hasRed',globleData.appStorage.hasRed)    
    //   if(globleData.updateRedpacket) globleData.updateRedpacket();
    // }else{
    //   if (globleData.gameSound && soudFlag) globleData.gameSound()   
    //   appBoot.showPop('.firstDiv,.mask,.imgbg,.oclose')      
    // }
    appBoot.setStorageValue('hasRed',1)
    // if(globleData.updateRedpacket) globleData.updateRedpacket();
    document.querySelector('.popDiv').style['margin-top'] = '0%'
    appBoot.showPop('.firstDiv,.mask,.imgbg')
    // appBoot.closePop('.oclose')
    // appBoot.showPop('#ocloseTime')
    html.getDom('.redValue').innerHTML = '恭喜发财，大吉大利'
    // setTimeout(function(){
        appBoot.showPop('.oclose')
    // },1000)
    appBoot.computeAD('.popDiv')
    appBoot.showBannerAD(true, false)

    // var sec = 3
    // html.getDom('#ocloseTime').innerHTML = sec
    // setInterval
    // var secTimeId = setInterval(()=>{
    //   sec--
    //   html.getDom('#ocloseTime').innerHTML = sec
    //   if(sec < 0){
    //     appBoot.closePop('#ocloseTime')
    //     appBoot.showPop('.oclose')
    //     clearInterval(secTimeId)
    //   }
    // },1000)
  },
  continueAD(callback){//过关广告
    if (globleData.tenClick) return
    // if(globleData.channel == globleData.hideChannel){
    //   if(callback) callback()
    //   return
    // }
    if(globleData.randomData.continue_game == 0){
      if(callback) callback()
      return
    }
    var curLevel = globleData.appStorage.curLevel
    if(globleData.curLevelMode == 1) {
      curLevel = globleData.appStorage.curLevelSurvival
    }
    var curRandom = globleData.randomData.continue_game.split(' ');
    if (curLevel <= Number(curRandom[0]) && curLevel%Number(curRandom[1]) == 0 || curLevel > Number(curRandom[0]) && curLevel%Number(curRandom[2]) == 0) {
      globleData.tenClick = true;

      appBoot.showAdBase(globleData.red_complete_pos, "", function(success){
          if (callback) callback()
          globleData.tenClick = false
      })
    }else{
      if (callback) callback()
    }
  },
  tryCloseAD(callback){//过关广告
    var curRandom = html.getRandomIntInclusive(1, 100);
    console.log('try random: ',curRandom)
    if (globleData.tenClick) return
    
    if (curRandom <= globleData.randomData.back_main_ad) {
        globleData.tenClick = true;
        appBoot.showAdBase( globleData.red_complete_pos,'',function(flag,data){
          if (callback) callback()
          globleData.tenClick = false
        })
    }else{
      if (callback) callback()
    }
  },
  playMusic(key, loop) {
    var obj={
      key: key,
      loop: loop
    };
    
    dsBridge.call('playMusic',obj,function(){})
  },
  stopMusic(key) {
    dsBridge.call('stopMusic',key,function(){})
  },
  showWithdraw3(){//3关开启提现
    // dsBridge.call('infoAdControl',globleData.appAd.on, ()=>{})
    appBoot.showPop('#getOpp')
    html.getDom('.balanceInfo').innerHTML = globleData.profile.amount
  },
  coinAnimate(left,top){
    // debugger
    
    appBoot.showPop('#coinAnimate')
    html.getDom('#iconP1').style.opacity = 1;
    html.getDom('#iconP1').style.left = '45%'
    html.getDom('#iconP1').style.top = '20%'
    setTimeout(function(){
      html.getDom('#iconP1').style.transform = 'scale(.2)';
      html.getDom('#iconP1').style.left = '70%'
      html.getDom('#iconP1').style.top = '20%'
      html.getDom('#iconP1').style.opacity = 0;
    },1000)
    setTimeout(function(){
      html.getDom('#iconP1').style.left = '40%'
      html.getDom('#iconP1').style.top = '20%'
      html.getDom('#iconP1').style.transform = 'scale(.8)';
      appBoot.closePop('#coinAnimate')
    },3000)
  },
  realGoWithdraw(){
    if (globleData.gameSound) globleData.gameSound()
      appBoot.closePop('#getOpDraw')
      // dsBridge.call('infoAdControl',globleData.appAd.off, ()=>{})
      appBoot.showInfoAdControl(false)
      if (globleData.profile.amount < Number(globleData.popName)) {
        appBoot.showToast('余额满'+globleData.popName+'元可提现')
        return
      }
      html.gotoWebpage('/my/withdraw','支付宝提现')
  },
  bannerAD(ele){
    // debugger
    var top = "-53%"
    let conPercent = (document.querySelector(ele).clientHeight*100/document.body.clientHeight)
    // globleData.appAd.on.percentH = Math.round(conPercent + globleData.adPercent/2 +  (100 - globleData.adPercent - conPercent)*2/3)
    dsBridge.call('bannerControl',true, function(){})
    // document.querySelector(ele == '.popDiv' ? ele : ele + ' .dialog-content').style['margin-top'] = '-' + (100 - globleData.adPercent + 10)/2 + '%' //(100 - data.infoAdHeight*100/data.screenHeight - 3) + '%'
    if( ele == '.drawPop'){
      top = "-36%"
    }
    document.querySelector(ele).style['margin-top'] = top //(100 - data.infoAdHeight*100/data.screenHeight - 3) + '%'
  },
  computeAD(ele, noAd){
    if(globleData.randomData.audit_stage == 1){
      return
    }
    // debugger
    var top = "-48%"
    // let conPercent = (document.querySelector(ele).clientHeight*100/document.body.clientHeight)
    // globleData.appAd.on.percentH = Math.round(conPercent + globleData.adPercent/2 +  (100 - globleData.adPercent - conPercent)*2/3)
    // dsBridge.call('infoAdControl',globleData.appAd.on, ()=>{})
    if(!noAd){
      appBoot.showInfoAdControl(true)
    }
    // document.querySelector(ele == '.popDiv' ? ele : ele + ' .dialog-content').style['margin-top'] = '-' + (100 - globleData.adPercent + 10)/2 + '%' //(100 - data.infoAdHeight*100/data.screenHeight - 3) + '%'
    if( ele == '.drawPop'){
      top = "-36%"
    }
    document.querySelector(ele).style['margin-top'] = top //(100 - data.infoAdHeight*100/data.screenHeight - 3) + '%'
  },
  redClose(){
      if (globleData.gameCallback) globleData.gameCallback()
      globleData.gameCallback = ''
      if (globleData.gameResume) globleData.gameResume()
      if (globleData.updateRedpacket) globleData.updateRedpacket()
      appBoot.showBannerAD(false, false)
  },
  levelCountCheck(){ // 每5次播放一个新插屏广告
    if(globleData.appStorage.levelCount < 5){ 
      globleData.appStorage.levelCount++
    }else{
      globleData.appStorage.levelCount = 0;
      appBoot.showAdBase(globleData.red_hint_complete_pos);
    }
    appBoot.setStorageValue('levelCount',globleData.appStorage.levelCount)
  },
  clickRedpacket(){ //点开红包，先看广告后获取金额
    // if (globleData.appStorage.firstOpen && !globleData.randomData.first_packet) {
    //   appBoot.openRedpacket(true)
    // }else{
      // appBoot.showAdBase(globleData.red_packet_pos,'' ,appBoot.openRedpacket);
    // }     
    // if (globleData.appStorage.firstOpen) {
    //   appBoot.setStorageValue('firstOpen',false);
    // } 

    // appBoot.redClose();
    // return
    if(globleData.appStorage.redOpened < globleData.randomData.red_packet){ 
      globleData.appStorage.redOpened++
      // appBoot.setStorageValue('redOpened',globleData.appStorage.redOpened)
      // appBoot.openRedpacket(true)
      appBoot.openAdiv();
    }else{
      globleData.appStorage.redOpened = 0;
      appBoot.showAdBase(globleData.red_packet_pos,'' ,appBoot.openRedpacket);
    }
    appBoot.setStorageValue('redOpened',globleData.appStorage.redOpened)
  },
  openRedpacket : function(success){
    if (!success) {
      appBoot.showToast()
      globleData.btnClicked = false;
      appBoot.redClose();
      return;
    }
    appBoot.fetchRedPacket(function(flag,data) {
      if (flag) { //开红包成功才改变状态
        appBoot.closePop('.pclose');
        html.getDom('.pclose2').setAttribute("class","btnWith pclose2 noActive");
        setTimeout(function(argument) {
          appBoot.showPop('.pclose');
          html.getDom('.pclose2').setAttribute("class","btnWith pclose2");
        },1000)
        // debugger
        appBoot.setStorageValue('hasRed',0)
        // globleData.rabValue = data.number
        globleData.profile.amount = data.balance_info
        appBoot.closePop('.firstDiv,.imgbg')
        appBoot.showPop('.popWith,.redShow,.mask,.imgbg2')
        html.getDom('.redText').innerHTML = '恭喜获得'
        html.getDom('.pclose2').innerHTML = '红包翻倍'

        // html.getDom('.redValue').innerHTML = data.number + '元'
        html.getDom('.redValue2').innerHTML = data.number + '<span>元</span>';
        html.getDom('.myBalance').innerHTML = data.balance_info
        globleData.btnClicked = false;
        // if (!globleData.appStorage.wheelEnable && Number(globleData.profile.amount) >= Number(globleData.randomData.luckydraw_amount)) {
        //   appBoot.setStorageValue('wheelEnable',true);
        //   appBoot.showPop('#wheel')
        // }
        // if(globleData.wheelCallback) globleData.wheelCallback()
        if(globleData.updateRedpacket) globleData.updateRedpacket();
        if (globleData.updateAmount) globleData.updateAmount()
        appBoot.computeAD('.popDiv')
      }else{
        appBoot.showToast()
      }
    })
  },
  doubleOpenRedpacket(){
    appBoot.showAdBase(globleData.red_double_pos,'' ,function (success,data) {
      if(success){
        globleData.profile.amount = data.balance_info
        html.getDom('.redText').innerHTML = '翻倍成功'
        html.getDom('.pclose2').innerHTML = "继续赚红包"
        html.getDom('.redValue2').innerHTML = (data.number)*2 + '<span>元</span>';
        html.getDom('.myBalance').innerHTML = data.balance_info

        
        // if(globleData.wheelCallback) globleData.wheelCallback()
        // if(globleData.updateRedpacket) globleData.updateRedpacket();
        if (globleData.updateAmount) globleData.updateAmount()
      }else{
        appBoot.showToast()
      }
    });
  },
  showWheel(){
      // alert("showWheel wheelEnable="+globleData.appStorage.wheelEnable);

      // alert("showWheel amount="+globleData.profile.amount);
      // alert("showWheel luckydraw_amount="+globleData.randomData.luckydraw_amount);
      if (!globleData.appStorage.wheelEnable && Number(globleData.profile.amount) >= Number(globleData.randomData.luckydraw_amount)) {
        // alert("showWheel showPop");
        appBoot.setStorageValue('wheelEnable',true);
        appBoot.showPop('#wheel')
      }
  },
  // countSmile(){//根据smile币显示红包
  //   if (globleData.channel == '90137') return;
  //   if (heroData.level == 1) {
  //     if (heroData.smile == 2 && !globleData.appStorage.showRedpacket[heroData.level+heroData.smile]) {

  //       appBoot.openAdiv()
  //     }
  //   }else if (heroData.level == 2) {
  //     if (heroData.smile % 4 == 0 && !globleData.appStorage.showRedpacket[heroData.level+heroData.smile]) {
  //       appBoot.openAdiv()
  //     }
  //   }else if (heroData.level == 3) {
  //     if (heroData.smile % 6 == 0 && !globleData.appStorage.showRedpacket[heroData.level+heroData.smile]) {
  //       appBoot.openAdiv()
  //     }
  //   }else if (heroData.level == 4) {
  //     if (heroData.smile % 8 == 0 && !globleData.appStorage.showRedpacket[heroData.level+heroData.smile]) {
  //       appBoot.openAdiv()
  //     }
  //   }else if (heroData.level == 5) {
  //     if (heroData.smile % 9 == 0 && !globleData.appStorage.showRedpacket[heroData.level+heroData.smile]) {
  //       appBoot.openAdiv()
  //     }
  //   }else if (heroData.level == 6) {
  //     if (heroData.smile % 10 == 0 && !globleData.appStorage.showRedpacket[heroData.level+heroData.smile]) {
  //       appBoot.openAdiv()
  //     }
  //   }else if (heroData.level == 7) {
  //     if (heroData.smile % 15 == 0 && !globleData.appStorage.showRedpacket[heroData.level+heroData.smile]) {
  //       appBoot.openAdiv()
  //     }
  //   }else if (heroData.level == 8) {
  //     if (heroData.smile % 20 == 0 && !globleData.appStorage.showRedpacket[heroData.level+heroData.smile]) {
  //       appBoot.openAdiv()
  //     }
  //   }else if (heroData.level == 9) {
  //     if (heroData.smile % 25 == 0 && !globleData.appStorage.showRedpacket[heroData.level+heroData.smile]) {
  //       appBoot.openAdiv()
  //     }
  //   }else if (heroData.level == 10) {
  //     if (heroData.smile % 30 == 0 && !globleData.appStorage.showRedpacket[heroData.level+heroData.smile]) {
  //       appBoot.openAdiv()
  //     }
  //   }else if (heroData.level == 11) {
  //     if (heroData.smile % 35 == 0 && !globleData.appStorage.showRedpacket[heroData.level+heroData.smile]) {
  //       appBoot.openAdiv()
  //     }
  //   }else if (heroData.level == 12) {
  //     if (heroData.smile % 40 == 0 && !globleData.appStorage.showRedpacket[heroData.level+heroData.smile]) {
  //       appBoot.openAdiv()
  //     }
  //   }else {
  //     if (heroData.smile % (40 + (heroData.level - 12)* 5) == 0 && !globleData.appStorage.showRedpacket[heroData.level+heroData.smile]) {
  //       appBoot.openAdiv()
  //     }
  //   }
  // },
  bind(){

    html.bind('.signClose', 'click', function(){ //关闭限时提现
        if (globleData.gameSound) globleData.gameSound()
        appBoot.closePop('#limitDiv')
        dsBridge.call('bannerControl',false, function(){})
    })
    
    html.bind('#signBtn', 'click', function(){ //关闭拆红包
      if (html.getDom('#signBtn').getAttribute('class') == 'gray') return
      if (globleData.gameSound) globleData.gameSound()
      if (globleData.activeData.progress == 3 || globleData.activeData.progress == 6) {
        appBoot.showToast(globleData.activeData.progress == 3 ? '2日后活动开启' : '限时50元活动稍后开启')
        return
      }
      appBoot.activeSignup()
    })
    html.bind('.oclose', 'click', function(){ //关闭拆红包
        if (globleData.gameSound) globleData.gameSound()
        globleData.newPeople = false;
        appBoot.closePop('.firstDiv,.mask,.imgbg')
      
      // if (globleData.showComment) {//关闭红包的时候显示评论
      //   globleData.showComment = false;
      //   dsBridge.call('storeReview', null, function(data, response){});
      // }
        // dsBridge.call('infoAdControl',globleData.appAd.off, ()=>{})
        appBoot.showInfoAdControl(false)
        appBoot.redClose();
    })
    
    html.bind('.clickBalance', 'click', function(){//看广告拆红包
      if (globleData.btnClicked) 
        return
      if (globleData.gameSound) globleData.gameSound()
      globleData.btnClicked = true;
        if (globleData.newPeople) {
          if (globleData.randomData.newbie_packet) {//新用户是否需要看广告
            appBoot.showAdBase(globleData.red_hint_pos, '',function(flag){
              newCallback()
            })
          }else{
            newCallback()
          }
          function newCallback() {
            appBoot.closePop('.firstDiv,.mask,.imgbg')
            appBoot.showPop('.popWith,.mask,.imgbg2')
            html.getDom('.pclose2').setAttribute("class","btnWith pclose2");
            html.getDom('.pclose2').innerHTML = "继续赚红包"
            html.getDom('.redText').innerHTML = '新手礼包'
            globleData.newPeople = false;
            globleData.btnClicked = false
            appBoot.closePop('.redShow')
            // html.getDom('.redValue').innerHTML = html.getQueryValue('gift') + '元';
            html.getDom('.redValue2').innerHTML = globleData.reggift + '<span>元</span>';
          }
        }else{
          // appBoot.clickRedpacket()
          // appBoot.openRedpacket(true)
          // dsBridge.call('infoAdControl',globleData.appAd.off, ()=>{})
          appBoot.showInfoAdControl(false)
          appBoot.showAdBase(globleData.red_packet_pos,'' ,appBoot.openRedpacket);
        }
    })
    html.bind('.pclose', 'click', function(){//余额关闭
      if (globleData.gameSound) globleData.gameSound()
        appBoot.closePop('.mask,.redPacket,.imgbg2,.redShow')
      // dsBridge.call('infoAdControl',globleData.appAd.off, ()=>{})
      appBoot.showInfoAdControl(false)
      appBoot.redClose();
    })
    html.bind('.pclose2', 'click', function(){//继续赚红包点击
      if (globleData.gameSound) globleData.gameSound()
      if (html.getDom('.pclose2').getAttribute('class').indexOf('noActive') >= 0) return
      if(html.getDom('.pclose2').outerText == "红包翻倍"){
        appBoot.doubleOpenRedpacket();
      }else{
        appBoot.closePop('.mask,.redPacket,.imgbg2,.redShow')
        // dsBridge.call('infoAdControl',globleData.appAd.off, ()=>{})
        appBoot.showInfoAdControl(false)
        appBoot.redClose();
      }
    })
    html.bind('.closeTips', 'click', function(){//关闭tips
      if (globleData.gameSound) globleData.gameSound()
        appBoot.closePop('.withTips')
      // dsBridge.call('infoAdControl',globleData.appAd.off, ()=>{})
    })
    // html.bind('#cancelClear', 'click', function(){//取消注销
    //   if (globleData.gameSound) globleData.gameSound()
    //     appBoot.closePop('#clearCong')
    //     // dsBridge.call('infoAdControl',globleData.appAd.off, ()=>{})
    // })
    // html.bind('#subClear', 'click', function(){//注销
    //   if (globleData.gameSound) globleData.gameSound()
    //   appBoot.clearConfig()

    // })
    html.bind('.btnWithGo', 'click', function(){//去提现
        // appBoot.btnWithdraw()
      if (globleData.gameSound) globleData.gameSound()

      if (Number(globleData.profile.amount) >= 150) {
        html.gotoWebpage('/my/withdraw','支付宝提现')
      }else{
        appBoot.showPop('.withTips')
      }
    })
    html.bind('#skip_ver', 'click', function(){//跳过版本检测
        if (globleData.gameSound) globleData.gameSound()
        appBoot.skipCheckVer()
    })
    html.bind('#skip_ver2', 'click', function(){//跳过版本检测
      if (globleData.gameSound) globleData.gameSound()
        appBoot.skipCheckVer()
    })
    html.bind('#btn_ver', 'click', function(){//确定检测
      if (globleData.gameSound) globleData.gameSound()
        appBoot.startCheckVer()
    })
    html.bind('#exit_app_ver', 'click', function(){//退出重启
      if (globleData.gameSound) globleData.gameSound()
        appBoot.exitApp()
    })
    
    html.bind('.goWheel','click',function() {
      if (globleData.gameSound) globleData.gameSound()
      appBoot.closePop('#wheel')
      html.gotoWebpage('/my/wheel','幸运大抽奖')
    })
    
     html.bind('.updateNow', 'click', function(){ //立即更新
      if (globleData.gameSound) globleData.gameSound()
      var updateUrl = globleData.checkVerData.url || '';
      if (updateUrl.indexOf('apk') > -1) {
        location.href = updateUrl
      }else{
        dsBridge.call('openURLInWebview',{title:'新版本更新',url:updateUrl},function(){});
      }
      // dsBridge.call('openapp',{path:updateUrl},function(){});
      appBoot.closePop('.popUpdate');
    })
    html.bind('.updateLater', 'click', function(){ //稍后更新
      if (globleData.gameSound) globleData.gameSound()
      globleData.showUpdateIcon = true;
      appBoot.setStorageValue('ignoreVer',globleData.checkVerData.target); 
      appBoot.closePop('.popUpdate');
      if(globleData.updateCallback) globleData.updateCallback()
    })
    html.bind('#cancelWorld', 'click', function(){//世界抢夺提示
      if (globleData.gameSound) globleData.gameSound()
      appBoot.closePop('#wordTips')
    })
     html.bind('#subWorld', 'click', function(){//去世界抢夺
      if (globleData.gameSound) globleData.gameSound()
      appBoot.closePop('#wordTips')
      html.gotoWebpage('/world','世界抢夺')
    })

    html.bind('.sclose', 'click', function(){//关闭设置
      if (globleData.gameSound) globleData.gameSound()
      appBoot.closePop('#stetting')
      appBoot.showInfoAdControl(false)
      if (globleData.pauseTimer) globleData.pauseTimer()
    })
    html.bind('#clearSet', 'click', function(){//注销
      if (globleData.gameSound) globleData.gameSound()
        // appBoot.closePop('#stetting')
        appBoot.showPop('#clearCong')
        appBoot.showBannerAD(true, false)
        appBoot.computeAD('#clearCong .dialog-content-ver', true);
    })

    html.bind('#subClear', 'click', function(){//确定注销
      if (globleData.gameSound) globleData.gameSound()
        appBoot.closePop('#clearCong')
        appBoot.closePop('#stetting')
        html.fetch({
          url:"/user/del_self",
          data:"uid="+globleData.uid,
          success : function (resData){
            if (resData.success) {
              localStorage.clear()
              dsBridge.call('clearConfig', function(data){
                dsBridge.call('exitApp', function(data, response){})
              }); 
            }
          },
        })
    })

    html.bind('#cancelClear', 'click', function(){//取消注销
      if (globleData.gameSound) globleData.gameSound()
        appBoot.showBannerAD(false, false)
        appBoot.closePop('#clearCong')
    })

    html.bind('#updateSet', 'click', function(){//版本升级
      if (globleData.gameSound) globleData.gameSound()
        appBoot.closePop('#stetting')
      appBoot.showInfoAdControl(false)
      dsBridge.call('openapp',{path:globleData.checkVerData.url},function(){});
    })
    html.bind('#chatSet', 'click', function(){//客服
      if (globleData.gameSound) globleData.gameSound()
        // html.gotoWebpage('/my/chat', '自助客服')
      if(html.getRandomIntInclusive(1, 100) <= globleData.randomData.customerservice_ad){
          appBoot.showAdBase(globleData.red_complete_pos, '', function(success){
              html.gotoWebpage('/my/chat', '自助客服')
          })
      }else{
          html.gotoWebpage('/my/chat', '自助客服')
      }
    })
    html.bind('.userPrivate3','click',function() {
      if (globleData.gameSound) globleData.gameSound()
      // html.gotoWebpage('/my/agreement?type=protocol','agreement')
      dsBridge.call('openURLInWebview',{title:"用户协议",url:globleData.protocol,needad:false,need_weixin:false,bar:true},function(){});
    })
    html.bind('.userPrivate4','click',function() {
      if (globleData.gameSound) globleData.gameSound()
      // html.gotoWebpage('/my/agreement?type=policy','agreement')
      dsBridge.call('openURLInWebview',{title:"隐私条款",url:globleData.policy,needad:false,need_weixin:false,bar:true},function(){});
    })
    html.bind('.clickBtn','click',function(argument) {
      if (globleData.gameSound) globleData.gameSound()
      if (!globleData.appStorage.chanceDraw) {
        appBoot.showToast('抽奖机会已过期')
        return
      }
      // html.getDom('.bgm').play()
      appBoot.fetchLuckdraw()
    })
    html.bind('.closeDraw', 'click', function(){ //关闭提现抽奖弹窗
      if (globleData.gameSound) globleData.gameSound()
      appBoot.closePop('#drawPop')
      // dsBridge.call('infoAdControl',globleData.appAd.off, ()=>{})
      appBoot.showInfoAdControl(false)
    })
    html.bind('.closeImg2', 'click', function(){ //关闭提现抽奖结果弹窗
        if (globleData.gameSound) globleData.gameSound()
        appBoot.closePop('#getOpDraw')
        // dsBridge.call('infoAdControl',globleData.appAd.off, ()=>{}) 
        appBoot.showInfoAdControl(false)
    })
    html.bind('.goWithdraw','click',function(argument) {
      if (globleData.gameSound) globleData.gameSound()
      appBoot.showToast("余额不足")
      appBoot.closePop('#getOpDraw')
      // dsBridge.call('infoAdControl',globleData.appAd.off, ()=>{})
      appBoot.showInfoAdControl(false)
    })
    html.bind('#subGameWheel', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      // if((globleData.chanceTarget-globleData.appStorage.red_count) == 0){
      if(globleData.chanceObj.show){
        appBoot.showDrawPop()
      }
      appBoot.closePop('#gameWheelTips')
      
    })
    html.bind('#subNote', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      // appBoot.closePop('#noteTips')
      if(globleData.noteType == "showAll"){
        appBoot.showAdHintShowAll(function(success){})
      }else{
        appBoot.showAdHintNote(function(success){})
      }
      
    })
    html.bind('.noteclose', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
       appBoot.closePop('#noteTips')
    })
    html.bind('#cancelGameWheel', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      appBoot.closePop('#gameWheelTips')
    })
    html.bind('#btn_age', 'click', function(){//适龄提示
      appBoot.closePop('#age')
    })
    html.bind('#subLastGame', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      globleData.lastGame = false
      appBoot.closePop('#lastGame')
      if (globleData.lastGameFun) globleData.lastGameFun()
    })
    html.bind('#cancelLastGame', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      globleData.lastGame = true
      appBoot.closePop('#lastGame')
      if (globleData.lastGameFun) globleData.lastGameFun()
    })
    html.bind('#pauseBox', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      appBoot.closePop('#pauseGame')
      appBoot.showInfoAdControl(false)
      if (globleData.pauseTimer) globleData.pauseTimer()
    })
    html.bind('#subWinGame', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      appBoot.closePop('#winGame')
      if (globleData.winGame) globleData.winGame()
    })
    html.bind('#clearRank', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      appBoot.closePop('#rank')
    })
    html.bind('#tabMenu0', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      appBoot.tabRank(globleData.GTYPE+"0")
    })
    html.bind('#tabMenu1', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      appBoot.tabRank(globleData.GTYPE+"1")
    })
    // html.bind('#tabMenu2', 'click', function(){
    //   if (globleData.gameSound) globleData.gameSound()
    //   appBoot.tabRank(2)
    // })

    html.bind('#checkAddSub', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      appBoot.showAdBase(globleData.red_hint_pos, "", function(e){
        // if(e){
        //   //TODO: quying 更新纠错总数
        //   appBoot.setStorageValue("Sudoku_ultimate_checkAllNum_" + s_iDifficultyMode.toString(), Number(globleData.randomData.correct)+2);
        //   if (globleData.checkText) globleData.checkText()
        // }
        if (globleData.puzzlePopFun) globleData.puzzlePopFun()
      })
      appBoot.closePop('#checkAdd')
      appBoot.showInfoAdControl(false)
    })
    // html.bind('#checkAddClose', 'click', function(){
    //   if (globleData.gameSound) globleData.gameSound()
    //   appBoot.closePop('#checkAdd')
    //   appBoot.showInfoAdControl(false)
    //   if (globleData.puzzlePopFun) globleData.puzzlePopFun()
    //   if (globleData.pauseTimer) globleData.pauseTimer()
    // })
    html.bind('#checkBtnSub', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      // appBoot.setStorageValue("Sudoku_ultimate_checkBtnClose_" + s_iDifficultyMode.toString(), true);
      //TODO: quying 改变纠错按钮状态
      if (globleData.openCheckBtn) globleData.openCheckBtn(true)
      appBoot.closePop('#checkBtn')
      appBoot.showInfoAdControl(false)
      if (globleData.pauseTimer) globleData.pauseTimer()
    })
    html.bind('#checkBtnClose', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      appBoot.closePop('#checkBtn')
      appBoot.showInfoAdControl(false)
      if (globleData.pauseTimer) globleData.pauseTimer()
    })
    html.bind('#checkNullSub', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      appBoot.showAdBase(globleData.red_hint_pos, "", function(e){
        if(e){
          //TODO: quying 填上正确的数
          if (globleData.checkNull) globleData.checkNull(true)
          if (globleData.pauseTimer) globleData.pauseTimer()
          appBoot.closePop('#checkNull')
          appBoot.showInfoAdControl(false)
        }
      })
    })
    html.bind('#checkNUllClose', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      appBoot.setStorageValue("Sudoku_ultimate_checkNullNoPop_" + s_iDifficultyMode.toString(), true);
      if (globleData.checkNull) globleData.checkNull(false)
      appBoot.closePop('#checkNull')
      appBoot.showInfoAdControl(false)
      if (globleData.pauseTimer) globleData.pauseTimer()
    })
    html.bind('#exitPopSub', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      appBoot.closePop('#exitPop')
      appBoot.showInfoAdControl(false)
      if (globleData.pauseTimer) globleData.pauseTimer()
      if (globleData.exitPop) globleData.exitPop()
    })
    html.bind('#exitPopClose', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      appBoot.closePop('#exitPop')
      appBoot.showInfoAdControl(false)
      if (globleData.pauseTimer) globleData.pauseTimer()
    })
    html.bind('#setTime', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      if(html.getDom("#setTimeIn").getAttribute('checked') == "true"){
        // html.getDom("#setTimeIn").removeAttribute('checked')
        html.getDom("#setTimeIn").setAttribute('checked',false)
        if (globleData.gameTimeBtn) globleData.gameTimeBtn(false)
      }else{
        html.getDom("#setTimeIn").setAttribute('checked',true)
        if (globleData.gameTimeBtn) globleData.gameTimeBtn(true)
      }
    })
    html.bind('#setSound', 'click', function(){
      if (globleData.gameSound) globleData.gameSound()
      if(html.getDom("#setSoundIn").getAttribute('checked') == "true"){
        // html.getDom("#setSoundIn").removeAttribute('checked')
        html.getDom("#setSoundIn").setAttribute('checked',false)
        if (globleData.gameSoundBtn) globleData.gameSoundBtn(false)
      }else{
        html.getDom("#setSoundIn").setAttribute('checked',true)
        if (globleData.gameSoundBtn) globleData.gameSoundBtn(true)
      }
    })
  },
  startGameLoadPre : function(){

    /***获取页面基本数据***/ 
    

    globleData.inAPP = html.browser.versions.app;
    // alert(navigator.userAgent.toLowerCase())
    if(dsBridge.hasNativeMethod('getEnv')){
        // alert('hasNativeMethod-getEnv')
      globleData.inAPP = true
      dsBridge.call('getEnv',function(data, response){
        // alert(JSON.stringify(data))
        if(typeof data == 'string'){
         data = JSON.parse(data);
        }
        console.log(123,data)
        globleData.uid = data.uid;
        globleData.token = data.token;
        globleData.channel = data.channel
        
        globleData.statusBar = Number(data.statusBarH);   
        globleData.bottomBarH = Number(data.bottomBarH)
        globleData.bottomBarHOld = Number(data.bottomBarH);
        globleData.bottomBarH = 0;
        globleData.statusBarHOld = Number(data.statusBarH);
        if(globleData.statusBarH < 44 && globleData.statusBarH > 0){
          globleData.statusBarH = 44;
        }

        if (data.real_name) {
          globleData.real_name = data.real_name
          var realName = data.real_name
          if(typeof data.real_name == 'string'){
            realName = JSON.parse(data.real_name);
          }
          if(realName.name){
            globleData.realName = true 
            appBoot.showPop("#realName")
          }else
            appBoot.closePop("#realName")
        }else{
          appBoot.closePop("#realName")
        }

        dsBridge.call('getScreenParam',function(data, response){
          //func.js:1367 {"infoAdHeight":633,"screenHeight":2160}
          // debugger
          // {"infoAdHeight":633,"screenHeight":2265}
          if(typeof data == 'string'){
            data = JSON.parse(data);
          }
          console.log(data)
          globleData.adPercent = (data.infoAdHeight*100/data.screenHeight)
        })
        // console.log('statusBarH:'+globleData.statusBarH)
        if(!globleData.uid){ 
          dsBridge.call('exitApp', function(data, response){})
        }   
        globleData.webVersion = data.webver;
        globleData.appVersion = data.appver;
        globleData.reggift = data.reggift ? Number(data.reggift) : 0
        
        appBoot.fetchNotice()
        appBoot.fetchRandom(function() {
          // appBoot.getFromAppLocalStorage();
        }); //获取随机数控制
        appBoot.getFromAppLocalStorage();
        // appBoot.fetchRankMinScore();
        appBoot.fetchProfile(function(argument) {
          //   // body...
          //   appBoot.getFromAppLocalStorage();
            if (globleData.channel != globleData.hideChannel){
              
              globleData.newPeople = globleData.reggift > 0 ? true : false
              appBoot.fetchActive();
              if (Number(globleData.profile.amount) < Number(globleData.randomData.luckydraw_amount)) {
                appBoot.setStorageValue('wheelEnable',false);
                // alert("wheelEnable="+globleData.appStorage.wheelEnable);
              }

            }
        });
        // alert('uid:'+globleData.uid)
        // alert('token:'+globleData.token)
        appBoot.dsAdResult();
        appBoot._showAdBase("-1");//预先取广告
        
        
        appBoot.fetchVersionCheck();
        
        appBoot.bind();
        
      })

    }else{
      globleData.uid = html.getQueryValue("uid");
      globleData.token = unescape(html.getQueryValue("token"));
      globleData.channel = html.getQueryValue("appchannel") || '90137';
      // debugger
      globleData.inAPP = html.browser.versions.app;
      globleData.statusBarH = Number(html.getQueryValue("statusBarH")) || globleData.statusBarH;
      globleData.bottomBarH = Number(html.getQueryValue("bottomBarH"));
      globleData.bottomBarHOld = Number(html.getQueryValue("bottomBarH"));
      globleData.bottomBarH = 0;
      globleData.statusBarHOld = Number(html.getQueryValue("statusBarH"));
      if(globleData.statusBarH < 44 && globleData.statusBarH > 0){
        globleData.statusBarH = 44;
      }

      var data = {"infoAdHeight":633,"screenHeight":2265}
          if(typeof data == 'string'){
            data = JSON.parse(data);
          }
          console.log(data)
          globleData.adPercent = (data.infoAdHeight*100/data.screenHeight)

      if (html.getQueryValue('gift')) globleData.newPeople = true
        globleData.reggift = html.getQueryValue('gift') ? Number(html.getQueryValue('gift')) : 0
      
      appBoot.fetchNotice()
      appBoot.fetchRandom(function() {
        // appBoot.getFromAppLocalStorage();
      }); //获取随机数控制
      // appBoot.fetchRankMinScore();
      appBoot.getFromAppLocalStorage();
      appBoot.fetchProfile(function(argument) {

        // appBoot.getFromAppLocalStorage();
        if (!globleData.randomData.audting){
          globleData.newPeople = globleData.reggift > 0 ? true : false
          appBoot.fetchActive();

        }
          if (Number(globleData.profile.amount) < Number(globleData.randomData.luckydraw_amount)) {
                appBoot.setStorageValue('wheelEnable',false);
                // alert("wheelEnable="+globleData.appStorage.wheelEnable);
          }
      });
      
      appBoot.dsAdResult();
      appBoot.bind();
      appBoot._showAdBase("-1");//预先取广告
    }

    
    
      dsBridge.register('childViewClose',function(data, response){
        // alert("childViewClose");
        appBoot.fetchProfile(()=> {
          // alert("fetchProfile updateAmount="+globleData.profile.amount);
          appBoot.getFromAppLocalStorage(()=> {})
          // if (globleData.wheelCallback) globleData.wheelCallback()
          if (globleData.updateAmount) globleData.updateAmount()
          // if (globleData.updateRedpacket) globleData.updateRedpacket()
          if (Number(globleData.profile.amount) < Number(globleData.randomData.luckydraw_amount)) {
                appBoot.setStorageValue('wheelEnable',false);
                // alert("wheelEnable="+globleData.appStorage.wheelEnable);
          }
        })
      })
    
    dsBridge.register('notification', (data, responseCallback) =>{
          // html.getDom('.fixedTest').innerHTML += data + ',' + globleData.musicON + ',' + typeof globleData.musicBG +' | '
        if (data == 'playBackAd') {//播放广告
          if(html.getRandomIntInclusive(1, 100) <= globleData.randomData.back_ad){
            // dsBridge.call('showSplash',function(data, response){})
            appBoot.showAdBase(globleData.red_complete_pos, '', function(success){})
          }
        }
        if (data == 'DidBecomeActive') {//前台激活成功
          if(globleData.gameMusicPlay) globleData.gameMusicPlay();
        }else if (data == 'WillResignActive'){//进入后台
          if(globleData.gameMusicStop) globleData.gameMusicStop();
        }
    })  
    dsBridge.call('getUrlParam',{},function(data, response){
      if(typeof data == 'string'){
       data = JSON.parse(data);
      }
      globleData.protocol = data.protocol_url
      globleData.policy = data.policy_url
    })

  },
  init : function(){
    appBoot.fetchRobnotify()
    loadSdk();
    if(location.origin.indexOf(globleData.GTYPE) > -1 || location.origin.indexOf("127.0.0.1") > -1){
      globleData.loadImgUrl = location.origin + "/static/zombie"
    }else{
      globleData.loadImgUrl = location.origin
    }
  },
};
appBoot.startGameLoadPre();








